%define anolis_release 1

Summary:          A complete ODBC driver manager for Linux
Name:             unixODBC
Version:          2.3.9
Release:          %{anolis_release}%{?dist}
URL:              http://www.unixODBC.org/
# Programs are GPL, libraries are LGPL, except News Server library is GPL.
License:          GPLv2+ and LGPLv2+

Source:           http://www.unixODBC.org/%{name}-%{version}.tar.gz
Source1:          odbcinst.ini
Source5:          README.dist

Patch8:           so-version-bump.patch
Patch9:           keep-typedefs.patch

Conflicts:        iodbc

BuildRequires:    make
BuildRequires:    automake autoconf libtool libtool-ltdl-devel bison flex
BuildRequires:    readline-devel
BuildRequires:    multilib-rpm-config

%description
Install unixODBC if you want to access databases through ODBC.
You will also need the mariadb-connector-odbc package if you want to access
a MySQL or MariaDB database, and/or the postgresql-odbc package for PostgreSQL.

%package devel
Summary: Development files for programs which will use the unixODBC library
Requires: %{name} = %{version}-%{release}

%description devel
The unixODBC package can be used to access databases through ODBC
drivers. If you want to develop programs that will access data through
ODBC, you need to install this package.

%prep
%autosetup -n %{name}-%{version} -p1

chmod 0644 Drivers/MiniSQL/*.c
chmod 0644 Drivers/nn/*.c
chmod 0644 Drivers/template/*.c
chmod 0644 doc/ProgrammerManual/Tutorial/*.html
chmod 0644 doc/lst/*
chmod 0644 include/odbcinst.h

autoreconf -vfi


%build
# unixODBC 2.2.14 is not aliasing-safe
CFLAGS="%{optflags} -fno-strict-aliasing"
CXXFLAGS="$CFLAGS"
export CFLAGS CXXFLAGS

%configure --with-gnu-ld=yes --enable-threads=yes \
	--enable-drivers=yes --enable-driverc=yes

# Get rid of the rpaths
sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool

make all

%install
make DESTDIR=$RPM_BUILD_ROOT install
install -m644 %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}
%multilib_fix_c_header --file %{_includedir}/unixodbc_conf.h

# add some explanatory documentation
cp %{SOURCE5} README.dist

# remove obsolete Postgres drivers from the package (but not the setup code)
rm -f $RPM_BUILD_ROOT%{_libdir}/libodbcpsql.so*

# make directory for unversioned plugins and create appropriate symlinks
mkdir $RPM_BUILD_ROOT%{_libdir}/%{name}
cd $RPM_BUILD_ROOT%{_libdir}/%{name}
ln -s ../libodbcpsqlS.so.2.0.0 libodbcpsqlS.so
ln -s ../libodbcmyS.so.2.0.0 libodbcmyS.so
ln -s ../libtdsS.so.2.0.0 libtdsS.so
cd -

# copy text driver documentation into main doc directory
# currently disabled because upstream no longer includes text driver
# mkdir -p doc/Drivers/txt
# cp -pr Drivers/txt/doc/* doc/Drivers/txt

# don't want to install doc Makefiles as docs
find doc -name 'Makefile*' | xargs rm

# we do not want to ship static libraries
rm -f $RPM_BUILD_ROOT%{_libdir}/*.a

# remove unpackaged files from the buildroot
rm -f $RPM_BUILD_ROOT%{_libdir}/*.la
rm -f $RPM_BUILD_ROOT%{_libdir}/libltdl.*
rm -rf $RPM_BUILD_ROOT%{_datadir}/libtool

# initialize lists of .so files
find $RPM_BUILD_ROOT%{_libdir} -name "*.so.*" | sed "s|^$RPM_BUILD_ROOT||" > base-so-list
find $RPM_BUILD_ROOT%{_libdir} -name "*.so"   | sed "s|^$RPM_BUILD_ROOT||" > devel-so-list

# move these to main package, they're often dlopened...
for lib in libodbcpsqlS.so libodbcmyS.so libtdsS.so
do
    echo "%{_libdir}/%{name}/$lib" >> base-so-list
    rm -f $RPM_BUILD_ROOT%{_libdir}/$lib
    grep -v "/$lib$" devel-so-list > devel-so-list.x
    mv -f devel-so-list.x devel-so-list
done

%files -f base-so-list
%doc README COPYING AUTHORS ChangeLog NEWS doc
%doc README.dist
%config(noreplace) %{_sysconfdir}/odbc*
%{_bindir}/odbcinst
%{_bindir}/isql
%{_bindir}/dltest
%{_bindir}/iusql
%{_bindir}/odbc_config
%{_bindir}/slencheck
%{_mandir}/man*/*

%files devel -f devel-so-list
%{_includedir}/*
%_libdir/pkgconfig/*.pc

%changelog
* Tue Jul 12 2022 happy_orange <songnannan@linux.alibaba.com> - 2.3.9-1
- Init pcakage from upstream
